#require 'youtubeDL/version.rb'
require 'securerandom'
require 'rufus-scheduler'

class YoutubeDL
	attr_accessor :options, :command, :output, :id, :downloadPath, :downloadProgress, :vidID, :running, :finished
	
	def initialize
		@id = SecureRandom.uuid
		@options = Array.new
		#@downloadPath = "/tmp/" << @id << ".mp4"
		#@downloadProgress = "/tmp/" << @id << "_progress.txt"
		#progressFile = File.open(@downloadProgress, "w+")
		#progressFile.close
		#$download_path = '/tmp/'.$videoID.'_'.session_id().'.%(ext)s';
        #$download_progress = '/tmp/'.$videoID.'_'.session_id().'_progress.txt';
	end

	def setVideo(videoID)
		@vidID = videoID
	end

	def getVideoPath
		return @downloadPath
	end

	# Your code goes here...
	def addOption(option)
		@options << option 
	end

	def execute
		@downloadPath = "/tmp/" << @id << ".mp4"
		@downloadProgress = "/tmp/" << @id << "_progress.txt"
		progressFile = File.open(@downloadProgress, "w+")
		progressFile.close
		#$command = 'youtube-dl -o "'.$download_path.'" --restrict-filenames --format=160/133/134/18 '.$videoID. ' > '.realpath(dirname(__FILE__)).$download_progress.' &';
		@command = "youtube-dl "
		@command << "-o \"" << @downloadPath << "\" "
		@options.each { |option| @command << option << " "}
		@command << @vidID << " "
		@command << "> \"" << @downloadProgress << "\" &"
		pid = spawn(@command)
		Process.detach(pid)
		@running = true
		@finished = false
	end

	def getProgress
		if @running
			text = File.open(@downloadProgress, "r").read
			text.gsub!(/\r/, "\n")
			lines = text.split(/\n/)
			if lines.size > 1
				line = lines[-1]
				spaceIdx = line.index(" ")
				percIdx = line.index("%")
				if percIdx != nil
					percentDone = line.slice(spaceIdx+1,percIdx-spaceIdx-1);
					if percentDone == "100"
					#	#File.close(@progressFile)
						#File.delete(@progressFile)
						@finished = true
						@running = false
					end
					return percentDone.to_f
				end
			end
		elsif @finished
			return 100
		end
			
	end

	def deleteProgress
		self.getProgress
		if @finished
			#File.close(@progressFile)
			File.delete(@downloadProgress)
		end
	end

end

